=== modified file 'Makefile'
--- Makefile	2010-08-16 19:00:59 +0000
+++ Makefile	2009-10-22 00:05:01 +0000
@@ -8,20 +8,16 @@
 #	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
-# <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
-LINK_FORTIFY_LD=-z relro -z now
-LINK_FORTIFY=
-ifndef BROKEN_PIE
-FORTIFY += -fPIE
-LINK_FORTIFY_LD += -fPIE
-LINK_FORTIFY += -pie
-endif
+# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
+# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
+LINK_FORTIFY_LD=-z relro -fPIE
+LINK_FORTIFY=-pie
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.14
+version=1.0.13
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -207,17 +203,6 @@
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
-	@echo "###################################################################"
-	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setuid: Operation not permitted             #"
-	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client: setuid: Operation not permitted             #"
-	@echo "#                     seteuid: Operation not permitted            #"
-	@echo "#                     klogctl: Operation not permitted            #"
-	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
@@ -230,13 +215,6 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE errors about \"No permission to bind to    #"
-	@echo "# interface\" or \"Could not open file u'/var/run/mandos.pid'\" -  #"
-	@echo "# they are harmless and are caused by the server not running as #"
-	@echo "# root.  Do NOT run \"make run-server\" server as root if you did #"
-	@echo "# not also unpack and compile it as root.                       #"
-	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server

=== modified file 'NEWS'
--- NEWS	2009-10-25 19:16:56 +0000
+++ NEWS	2009-10-22 00:05:01 +0000
@@ -1,9 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.0.14 (2009-10-25)
-Enable building without -pie and -fPIE if BROKEN_PIE is set.
-
 Version 1.0.13 (2009-10-22)
 * Client
 ** Security bug fix: If Mandos server is also installed, do not copy

=== modified file 'TODO'
--- TODO	2009-09-17 11:47:22 +0000
+++ TODO	2009-10-18 17:29:55 +0000
@@ -2,30 +2,42 @@
 
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 ** TODO [#B] Retry a server which has a non-definite reply:
 *** A closed connection during the TLS handshake
 *** A TCP timeout
 ** TODO [#B] Use capabilities instead of seteuid().
+** TODO use EX_* from <sysexits.h>
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 
 * usplash
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
+** TODO use EX_* from <sysexits.h>
 
 * askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
+** TODO lock stdin (with flock()?)
+
+* TODO passdev
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
+** TODO use EX_* from <sysexits.h>
+** TODO use error() instead of perror()
 
 * mandos (server)
 ** TODO [#B] Log level				:BUGS:
@@ -46,11 +58,19 @@
 ** TODO Date+time on console log messages	:BUGS:
    Is this the default?
 ** TODO DBusServiceObjectUsingSuper
-** Global enable/disable flag
-** By-client countdown on secrets given
-** Fix problem with fsck taking a really long time
+** TODO Global enable/disable flag
+** TODO By-client countdown on secrets given
+** TODO Fix problem with fsck taking a really long time
    Whenever a client successfully gets a secret it could get a
    one-time timeout boost to allow for an fsck-incurred delay
+** TODO Delay before client receives key
+   This would give an operator opportunity to cancel the request if
+   desired.
+** TODO Client manual approval mode
+   A client needs manual approval on the server before it gets the
+   secret
+** TODO Persistent state
+   /var/lib/mandos/*
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
@@ -61,9 +81,14 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 
+* TODO mandos-dispatch
+  Listens for specified D-Bus signals and spawns shell commands with
+  arguments.
+
 * mandos-monitor
-** D-Bus mail loop w/ signal receiver
-** Snack/Newt client data displayer
+** D-Bus main loop w/ signal receiver
+** Urwid client data displayer
+*** Urwid scaffolding
 *** Client Widgets
 *** Properties popup
 

=== modified file 'common.ent'
--- common.ent	2009-10-25 19:16:56 +0000
+++ common.ent	2009-10-22 00:05:01 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.0.14">
+<!ENTITY version "1.0.13">

=== modified file 'debian/changelog'
--- debian/changelog	2009-10-25 19:16:56 +0000
+++ debian/changelog	2009-10-22 00:05:01 +0000
@@ -1,11 +1,3 @@
-mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
-
-  * New upstream release.
-  * debian/rules: Build with BROKEN_PIE set on mips and mipsel
-    architectures - fixes FTBFS there.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 25 Oct 2009 20:10:09 +0100
-
 mandos (1.0.13-1) unstable; urgency=high
 
   * New upstream release.

=== modified file 'debian/rules'
--- debian/rules	2009-10-25 19:06:56 +0000
+++ debian/rules	2009-01-18 00:18:50 +0000
@@ -15,15 +15,6 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
-ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-
 configure: configure-stamp
 configure-stamp:
 	dh_testdir

=== modified file 'mandos'
--- mandos	2009-10-25 19:16:56 +0000
+++ mandos	2009-10-22 00:05:01 +0000
@@ -67,6 +67,8 @@
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
+import xml.dom.minidom
+import inspect
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -77,7 +79,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.0.14"
+version = "1.0.13"
 
 logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -174,7 +176,8 @@
                                     self.server.EntryGroupNew()),
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
             self.group.connect_to_signal('StateChanged',
-                                         self.entry_group_state_changed)
+                                         self
+                                         .entry_group_state_changed)
         logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -246,7 +249,7 @@
                                     to see if the client lives.
                                     'None' if no process is running.
     checker_initiator_tag: a gobject event source tag, or None
-    disable_initiator_tag:    - '' -
+    disable_initiator_tag: - '' -
     checker_callback_tag:  - '' -
     checker_command: string; External command which is run to check if
                      client lives.  %() expansions are done at
@@ -256,19 +259,19 @@
     """
     
     @staticmethod
-    def _datetime_to_milliseconds(dt):
-        "Convert a datetime.datetime() to milliseconds"
-        return ((dt.days * 24 * 60 * 60 * 1000)
-                + (dt.seconds * 1000)
-                + (dt.microseconds // 1000))
+    def _timedelta_to_milliseconds(td):
+        "Convert a datetime.timedelta() to milliseconds"
+        return ((td.days * 24 * 60 * 60 * 1000)
+                + (td.seconds * 1000)
+                + (td.microseconds // 1000))
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return self._datetime_to_milliseconds(self.timeout)
+        return self._timedelta_to_milliseconds(self.timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return self._datetime_to_milliseconds(self.interval)
+        return self._timedelta_to_milliseconds(self.interval)
     
     def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -289,7 +292,8 @@
         elif u"secfile" in config:
             with closing(open(os.path.expanduser
                               (os.path.expandvars
-                               (config[u"secfile"])))) as secfile:
+                               (config[u"secfile"])),
+                              "rb")) as secfile:
                 self.secret = secfile.read()
         else:
             raise TypeError(u"No secret or secfile for client %s"
@@ -395,8 +399,13 @@
         # is as it should be.
         
         # If a checker exists, make sure it is not a zombie
-        if self.checker is not None:
+        try:
             pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+        except (AttributeError, OSError), error:
+            if (isinstance(error, OSError)
+                and error.errno != errno.ECHILD):
+                raise error
+        else:
             if pid:
                 logger.warning(u"Checker was a zombie")
                 gobject.source_remove(self.checker_callback_tag)
@@ -477,7 +486,187 @@
             return now < (self.last_checked_ok + self.timeout)
 
 
-class ClientDBus(Client, dbus.service.Object):
+def dbus_service_property(dbus_interface, signature=u"v",
+                          access=u"readwrite", byte_arrays=False):
+    """Decorators for marking methods of a DBusObjectWithProperties to
+    become properties on the D-Bus.
+    
+    The decorated method will be called with no arguments by "Get"
+    and with one argument by "Set".
+    
+    The parameters, where they are supported, are the same as
+    dbus.service.method, except there is only "signature", since the
+    type from Get() and the type sent to Set() is the same.
+    """
+    def decorator(func):
+        func._dbus_is_property = True
+        func._dbus_interface = dbus_interface
+        func._dbus_signature = signature
+        func._dbus_access = access
+        func._dbus_name = func.__name__
+        if func._dbus_name.endswith(u"_dbus_property"):
+            func._dbus_name = func._dbus_name[:-14]
+        func._dbus_get_args_options = {u'byte_arrays': byte_arrays }
+        return func
+    return decorator
+
+
+class DBusPropertyException(dbus.exceptions.DBusException):
+    """A base class for D-Bus property-related exceptions
+    """
+    def __unicode__(self):
+        return unicode(str(self))
+
+
+class DBusPropertyAccessException(DBusPropertyException):
+    """A property's access permissions disallows an operation.
+    """
+    pass
+
+
+class DBusPropertyNotFound(DBusPropertyException):
+    """An attempt was made to access a non-existing property.
+    """
+    pass
+
+
+class DBusObjectWithProperties(dbus.service.Object):
+    """A D-Bus object with properties.
+
+    Classes inheriting from this can use the dbus_service_property
+    decorator to expose methods as D-Bus properties.  It exposes the
+    standard Get(), Set(), and GetAll() methods on the D-Bus.
+    """
+    
+    @staticmethod
+    def _is_dbus_property(obj):
+        return getattr(obj, u"_dbus_is_property", False)
+    
+    def _get_all_dbus_properties(self):
+        """Returns a generator of (name, attribute) pairs
+        """
+        return ((prop._dbus_name, prop)
+                for name, prop in
+                inspect.getmembers(self, self._is_dbus_property))
+    
+    def _get_dbus_property(self, interface_name, property_name):
+        """Returns a bound method if one exists which is a D-Bus
+        property with the specified name and interface.
+        """
+        for name in (property_name,
+                     property_name + u"_dbus_property"):
+            prop = getattr(self, name, None)
+            if (prop is None
+                or not self._is_dbus_property(prop)
+                or prop._dbus_name != property_name
+                or (interface_name and prop._dbus_interface
+                    and interface_name != prop._dbus_interface)):
+                continue
+            return prop
+        # No such property
+        raise DBusPropertyNotFound(self.dbus_object_path + u":"
+                                   + interface_name + u"."
+                                   + property_name)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ss",
+                         out_signature=u"v")
+    def Get(self, interface_name, property_name):
+        """Standard D-Bus property Get() method, see D-Bus standard.
+        """
+        prop = self._get_dbus_property(interface_name, property_name)
+        if prop._dbus_access == u"write":
+            raise DBusPropertyAccessException(property_name)
+        value = prop()
+        if not hasattr(value, u"variant_level"):
+            return value
+        return type(value)(value, variant_level=value.variant_level+1)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ssv")
+    def Set(self, interface_name, property_name, value):
+        """Standard D-Bus property Set() method, see D-Bus standard.
+        """
+        prop = self._get_dbus_property(interface_name, property_name)
+        if prop._dbus_access == u"read":
+            raise DBusPropertyAccessException(property_name)
+        if prop._dbus_get_args_options[u"byte_arrays"]:
+            value = dbus.ByteArray(''.join(unichr(byte)
+                                           for byte in value))
+        prop(value)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"s",
+                         out_signature=u"a{sv}")
+    def GetAll(self, interface_name):
+        """Standard D-Bus property GetAll() method, see D-Bus
+        standard.
+
+        Note: Will not include properties with access="write".
+        """
+        all = {}
+        for name, prop in self._get_all_dbus_properties():
+            if (interface_name
+                and interface_name != prop._dbus_interface):
+                # Interface non-empty but did not match
+                continue
+            # Ignore write-only properties
+            if prop._dbus_access == u"write":
+                continue
+            value = prop()
+            if not hasattr(value, u"variant_level"):
+                all[name] = value
+                continue
+            all[name] = type(value)(value, variant_level=
+                                    value.variant_level+1)
+        return dbus.Dictionary(all, signature=u"sv")
+    
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature=u"s",
+                         path_keyword='object_path',
+                         connection_keyword='connection')
+    def Introspect(self, object_path, connection):
+        """Standard D-Bus method, overloaded to insert property tags.
+        """
+        xmlstring = dbus.service.Object.Introspect(self, object_path,
+                                                   connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+            def make_tag(document, name, prop):
+                e = document.createElement(u"property")
+                e.setAttribute(u"name", name)
+                e.setAttribute(u"type", prop._dbus_signature)
+                e.setAttribute(u"access", prop._dbus_access)
+                return e
+            for if_tag in document.getElementsByTagName(u"interface"):
+                for tag in (make_tag(document, name, prop)
+                            for name, prop
+                            in self._get_all_dbus_properties()
+                            if prop._dbus_interface
+                            == if_tag.getAttribute(u"name")):
+                    if_tag.appendChild(tag)
+                # Add the names to the return values for the
+                # "org.freedesktop.DBus.Properties" methods
+                if (if_tag.getAttribute(u"name")
+                    == u"org.freedesktop.DBus.Properties"):
+                    for cn in if_tag.getElementsByTagName(u"method"):
+                        if cn.getAttribute(u"name") == u"Get":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"value")
+                        elif cn.getAttribute(u"name") == u"GetAll":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"props")
+            xmlstring = document.toxml(u"utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError), error:
+            logger.error(u"Failed to override Introspection method",
+                         error)
+        return xmlstring
+
+
+class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
     Attributes:
@@ -494,8 +683,8 @@
         self.dbus_object_path = (dbus.ObjectPath
                                  (u"/clients/"
                                   + self.name.replace(u".", u"_")))
-        dbus.service.Object.__init__(self, self.bus,
-                                     self.dbus_object_path)
+        DBusObjectWithProperties.__init__(self, self.bus,
+                                          self.dbus_object_path)
     
     @staticmethod
     def _datetime_to_dbus(dt, variant_level=0):
@@ -530,8 +719,8 @@
             self.remove_from_connection()
         except LookupError:
             pass
-        if hasattr(dbus.service.Object, u"__del__"):
-            dbus.service.Object.__del__(self, *args, **kwargs)
+        if hasattr(DBusObjectWithProperties, u"__del__"):
+            DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
     
     def checker_callback(self, pid, condition, command,
@@ -611,63 +800,15 @@
         "D-Bus signal"
         pass
     
-    # GetAllProperties - method
-    @dbus.service.method(_interface, out_signature=u"a{sv}")
-    def GetAllProperties(self):
-        "D-Bus method"
-        return dbus.Dictionary({
-                dbus.String(u"name"):
-                    dbus.String(self.name, variant_level=1),
-                dbus.String(u"fingerprint"):
-                    dbus.String(self.fingerprint, variant_level=1),
-                dbus.String(u"host"):
-                    dbus.String(self.host, variant_level=1),
-                dbus.String(u"created"):
-                    self._datetime_to_dbus(self.created,
-                                           variant_level=1),
-                dbus.String(u"last_enabled"):
-                    (self._datetime_to_dbus(self.last_enabled,
-                                            variant_level=1)
-                     if self.last_enabled is not None
-                     else dbus.Boolean(False, variant_level=1)),
-                dbus.String(u"enabled"):
-                    dbus.Boolean(self.enabled, variant_level=1),
-                dbus.String(u"last_checked_ok"):
-                    (self._datetime_to_dbus(self.last_checked_ok,
-                                            variant_level=1)
-                     if self.last_checked_ok is not None
-                     else dbus.Boolean (False, variant_level=1)),
-                dbus.String(u"timeout"):
-                    dbus.UInt64(self.timeout_milliseconds(),
-                                variant_level=1),
-                dbus.String(u"interval"):
-                    dbus.UInt64(self.interval_milliseconds(),
-                                variant_level=1),
-                dbus.String(u"checker"):
-                    dbus.String(self.checker_command,
-                                variant_level=1),
-                dbus.String(u"checker_running"):
-                    dbus.Boolean(self.checker is not None,
-                                 variant_level=1),
-                dbus.String(u"object_path"):
-                    dbus.ObjectPath(self.dbus_object_path,
-                                    variant_level=1)
-                }, signature=u"sv")
-    
-    # IsStillValid - method
-    @dbus.service.method(_interface, out_signature=u"b")
-    def IsStillValid(self):
-        return self.still_valid()
-    
     # PropertyChanged - signal
     @dbus.service.signal(_interface, signature=u"sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
         pass
     
-    # ReceivedSecret - signal
+    # GotSecret - signal
     @dbus.service.signal(_interface)
-    def ReceivedSecret(self):
+    def GotSecret(self):
         "D-Bus signal"
         pass
     
@@ -677,50 +818,6 @@
         "D-Bus signal"
         pass
     
-    # SetChecker - method
-    @dbus.service.method(_interface, in_signature=u"s")
-    def SetChecker(self, checker):
-        "D-Bus setter method"
-        self.checker_command = checker
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
-    
-    # SetHost - method
-    @dbus.service.method(_interface, in_signature=u"s")
-    def SetHost(self, host):
-        "D-Bus setter method"
-        self.host = host
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"host"),
-                             dbus.String(self.host, variant_level=1))
-    
-    # SetInterval - method
-    @dbus.service.method(_interface, in_signature=u"t")
-    def SetInterval(self, milliseconds):
-        self.interval = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"interval"),
-                             (dbus.UInt64(self.interval_milliseconds(),
-                                          variant_level=1)))
-    
-    # SetSecret - method
-    @dbus.service.method(_interface, in_signature=u"ay",
-                         byte_arrays=True)
-    def SetSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = str(secret)
-    
-    # SetTimeout - method
-    @dbus.service.method(_interface, in_signature=u"t")
-    def SetTimeout(self, milliseconds):
-        self.timeout = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"timeout"),
-                             (dbus.UInt64(self.timeout_milliseconds(),
-                                          variant_level=1)))
-    
     # Enable - method
     @dbus.service.method(_interface)
     def Enable(self):
@@ -744,6 +841,142 @@
     def StopChecker(self):
         self.stop_checker()
     
+    # name - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def name_dbus_property(self):
+        return dbus.String(self.name)
+    
+    # fingerprint - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def fingerprint_dbus_property(self):
+        return dbus.String(self.fingerprint)
+    
+    # host - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def host_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.String(self.host)
+        self.host = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"host"),
+                             dbus.String(value, variant_level=1))
+    
+    # created - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def created_dbus_property(self):
+        return dbus.String(self._datetime_to_dbus(self.created))
+    
+    # last_enabled - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def last_enabled_dbus_property(self):
+        if self.last_enabled is None:
+            return dbus.String(u"")
+        return dbus.String(self._datetime_to_dbus(self.last_enabled))
+    
+    # enabled - property
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
+    def enabled_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.Boolean(self.enabled)
+        if value:
+            self.enable()
+        else:
+            self.disable()
+    
+    # last_checked_ok - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def last_checked_ok_dbus_property(self, value=None):
+        if value is not None:
+            self.checked_ok()
+            return
+        if self.last_checked_ok is None:
+            return dbus.String(u"")
+        return dbus.String(self._datetime_to_dbus(self
+                                                  .last_checked_ok))
+    
+    # timeout - property
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
+    def timeout_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.timeout_milliseconds())
+        self.timeout = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"timeout"),
+                             dbus.UInt64(value, variant_level=1))
+        if getattr(self, u"disable_initiator_tag", None) is None:
+            return
+        # Reschedule timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = None
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
+        if time_to_die <= 0:
+            # The timeout has passed
+            self.disable()
+        else:
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (time_to_die, self.disable))
+    
+    # interval - property
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
+    def interval_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.interval_milliseconds())
+        self.interval = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"interval"),
+                             dbus.UInt64(value, variant_level=1))
+        if getattr(self, u"checker_initiator_tag", None) is None:
+            return
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
+
+    # checker - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def checker_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.String(self.checker_command)
+        self.checker_command = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"checker"),
+                             dbus.String(self.checker_command,
+                                         variant_level=1))
+    
+    # checker_running - property
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
+    def checker_running_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.Boolean(self.checker is not None)
+        if value:
+            self.start_checker()
+        else:
+            self.stop_checker()
+    
+    # object_path - property
+    @dbus_service_property(_interface, signature=u"o", access=u"read")
+    def object_path_dbus_property(self):
+        return self.dbus_object_path # is already a dbus.ObjectPath
+    
+    # secret = property
+    @dbus_service_property(_interface, signature=u"ay",
+                           access=u"write", byte_arrays=True)
+    def secret_dbus_property(self, value):
+        self.secret = str(value)
+    
     del _interface
 
 
@@ -983,9 +1216,6 @@
         clients:        set of Client objects
         gnutls_priority GnuTLS priority string
         use_dbus:       Boolean; to emit D-Bus signals or not
-        clients:        set of Client objects
-        gnutls_priority GnuTLS priority string
-        use_dbus:       Boolean; to emit D-Bus signals or not
     
     Assumes a gobject.MainLoop event loop.
     """
@@ -1071,7 +1301,7 @@
                     client.checked_ok()
                     if self.use_dbus:
                         # Emit D-Bus signal
-                        client.ReceivedSecret()
+                        client.GotSecret()
                     break
             else:
                 logger.error(u"Sending secret to unknown client %s",
@@ -1162,7 +1392,8 @@
         null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          u"/dev/null not a character device")
+                          u"%s not a character device"
+                          % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -1172,7 +1403,7 @@
 
 def main():
     
-    ######################################################################
+    ##################################################################
     # Parsing of options, both command line and config file
     
     parser = optparse.OptionParser(version = "%%prog %s" % version)
@@ -1196,8 +1427,8 @@
                       help=u"Directory to search for configuration"
                       u" files")
     parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+                      dest=u"use_dbus", help=u"Do not provide D-Bus"
+                      u" system bus interface")
     parser.add_option("--no-ipv6", action=u"store_false",
                       dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
@@ -1255,7 +1486,6 @@
     # For convenience
     debug = server_settings[u"debug"]
     use_dbus = server_settings[u"use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     use_ipv6 = server_settings[u"use_ipv6"]
     
     if not debug:
@@ -1429,7 +1659,7 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAllProperties())
+                    ((c.dbus_object_path, c.GetAll(u""))
                      for c in tcp_server.clients),
                     signature=u"oa{sv}")
             
@@ -1455,7 +1685,7 @@
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path,
-                                            client.GetAllProperties())
+                                            client.GetAll(u""))
         client.enable()
     
     tcp_server.enable()

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-10-25 19:16:56 +0000
+++ mandos-ctl	2009-10-22 00:05:01 +0000
@@ -31,25 +31,27 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.14"
+version = "1.0.13"
 bus = dbus.SystemBus()
 mandos_dbus_objc = bus.get_object(busname, server_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,
                              dbus_interface = server_interface)
 mandos_clients = mandos_serv.GetAllClientsWithProperties()
 
-def datetime_to_milliseconds(dt):
-    "Return the 'timeout' attribute in milliseconds"
-    return ((dt.days * 24 * 60 * 60 * 1000)
-            + (dt.seconds * 1000)
-            + (dt.microseconds // 1000))
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta object to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return "%s%02d:%02d:%02d" % (("%dT" % td.days) if td.days else "", # days
-                           td.seconds // 3600,        # hours
-                           (td.seconds % 3600) // 60, # minutes
-                           (td.seconds % 60))         # seconds
+    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+            % { "days": "%dT" % td.days if td.days else "",
+                "hours": td.seconds // 3600,
+                "minutes": (td.seconds % 3600) // 60,
+                "seconds": td.seconds % 60,
+                })
 
 
 def string_to_delta(interval):
@@ -96,16 +98,18 @@
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
             return u"Yes" if value else u"No"
-        if keyword in ("timeout", "interval"):
+        if keyword in (u"timeout", u"interval"):
             return milliseconds_to_string(value)
         return unicode(value)
     
+    # Create format string to print table rows
     format_string = u' '.join(u'%%-%ds' %
                               max(len(tablewords[key]),
                                   max(len(valuetostring(client[key], key))
                                       for client in
                                       clients))
                               for key in keywords)
+    # Print header line
     print format_string % tuple(tablewords[key] for key in keywords)
     for client in clients:
         print format_string % tuple(valuetostring(client[key], key)
@@ -146,9 +150,7 @@
     for path, client in mandos_clients.iteritems():
         if client['name'] == name:
             client_objc = bus.get_object(busname, path)
-            clients.append(dbus.Interface(client_objc,
-                                          dbus_interface
-                                          = client_interface))
+            clients.append(client_objc)
             break
     else:
         print >> sys.stderr, "Client not found on server: %r" % name
@@ -167,27 +169,37 @@
     if options.remove:
         mandos_serv.RemoveClient(client.__dbus_object_path__)
     if options.enable:
-        client.Enable()
+        client.Enable(dbus_interface=client_interface)
     if options.disable:
-        client.Disable()
+        client.Disable(dbus_interface=client_interface)
     if options.bump_timeout:
-        client.BumpTimeout()
+        client.CheckedOK(dbus_interface=client_interface)
     if options.start_checker:
-        client.StartChecker()
+        client.StartChecker(dbus_interface=client_interface)
     if options.stop_checker:
-        client.StopChecker()
+        client.StopChecker(dbus_interface=client_interface)
     if options.is_valid:
-        sys.exit(0 if client.IsStillValid() else 1)
+        sys.exit(0 if client.Get(client_interface,
+                                 u"enabled",
+                                 dbus_interface=dbus.PROPERTIES_IFACE)
+                 else 1)
     if options.checker:
-        client.SetChecker(options.checker)
+        client.Set(client_interface, u"checker", options.checker,
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.host:
-        client.SetHost(options.host)
+        client.Set(client_interface, u"host", options.host,
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.interval:
-        client.SetInterval(datetime_to_milliseconds
-                           (string_to_delta(options.interval)))
+        client.Set(client_interface, u"interval",
+                   timedelta_to_milliseconds
+                   (string_to_delta(options.interval)),
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.timeout:
-        client.SetTimeout(datetime_to_milliseconds
-                          (string_to_delta(options.timeout)))
+        client.Set(client_interface, u"timeout",
+                   timedelta_to_milliseconds(string_to_delta
+                                             (options.timeout)),
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.secret:
-        client.SetSecret(dbus.ByteArray(open(options.secret, 'rb').read()))
-    
+        client.Set(client_interface, u"secret",
+                   dbus.ByteArray(open(options.secret, u'rb').read()),
+                   dbus_interface=dbus.PROPERTIES_IFACE)

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-10-25 19:16:56 +0000
+++ mandos-keygen	2009-10-22 00:05:01 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.14"
+VERSION="1.0.13"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-10-25 19:16:56 +0000
+++ mandos.lsm	2009-10-22 00:05:01 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.14
-Entered-date:	2009-10-25
+Version:	1.0.13
+Entered-date:	2009-10-22
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      103K mandos_1.0.14.orig.tar.gz
+	      103K mandos_1.0.13.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		103K mandos_1.0.14.orig.tar.gz
+		103K mandos_1.0.13.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2009-09-17 11:47:22 +0000
+++ mandos.xml	2009-09-17 01:21:27 +0000
@@ -86,6 +86,8 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
+      <arg><option>--no-dbus</option></arg>
+      <sbr/>
       <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -233,6 +235,16 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--no-dbus</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
+	  <para>
+	    See also <xref linkend="dbus_interface"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--no-ipv6</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
@@ -336,6 +348,16 @@
     </para>
   </refsect1>
   
+  <refsect1 id="dbus_interface">
+    <title>D-BUS INTERFACE</title>
+    <para>
+      The server will by default provide a D-Bus system bus interface.
+      This interface will only be accessible by the root user or a
+      Mandos-specific user, if such a user exists.
+      <!-- XXX -->
+    </para>
+  </refsect1>
+  
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-09-10 06:28:14 +0000
+++ plugin-runner.c	2009-09-23 08:52:09 +0000
@@ -23,14 +23,14 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   asprintf() */
+				   asprintf(), O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_FAILURE,
 				   EXIT_SUCCESS, realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* perror, fileno(), fprintf(),
 				   stderr, STDOUT_FILENO */
-#include <sys/types.h>	        /* DIR, opendir(), stat(), struct
+#include <sys/types.h>	        /* DIR, fdopendir(), stat(), struct
 				   stat, waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), wait(), pid_t,
 				   uid_t, gid_t, getuid(), getgid(),
@@ -42,7 +42,7 @@
 				   WCOREDUMP() */
 #include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* DIR, struct dirent, opendir(),
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
 				   readdir(), closedir(), dirfd() */
 #include <unistd.h>		/* struct stat, stat(), S_ISREG(),
 				   fcntl(), setuid(), setgid(),
@@ -698,28 +698,49 @@
     perror("setuid");
   }
   
-  if(plugindir == NULL){
-    dir = opendir(PDIR);
-  } else {
-    dir = opendir(plugindir);
-  }
-  
-  if(dir == NULL){
-    perror("Could not open plugin dir");
-    exitstatus = EXIT_FAILURE;
-    goto fallback;
-  }
-  
-  /* Set the FD_CLOEXEC flag on the directory, if possible */
+  /* Open plugin directory with close_on_exec flag */
   {
-    int dir_fd = dirfd(dir);
-    if(dir_fd >= 0){
-      ret = set_cloexec_flag(dir_fd);
-      if(ret < 0){
-	perror("set_cloexec_flag");
-	exitstatus = EXIT_FAILURE;
-	goto fallback;
-      }
+    int dir_fd = -1;
+    if(plugindir == NULL){
+      dir_fd = open(PDIR, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    } else {
+      dir_fd = open(plugindir, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    }
+    if(dir_fd == -1){
+      perror("Could not open plugin dir");
+      exitstatus = EXIT_FAILURE;
+      goto fallback;
+    }
+    
+#ifndef O_CLOEXEC
+  /* Set the FD_CLOEXEC flag on the directory */
+    ret = set_cloexec_flag(dir_fd);
+    if(ret < 0){
+      perror("set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EXIT_FAILURE;
+      goto fallback;
+    }
+#endif	/* O_CLOEXEC */
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      perror("Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EXIT_FAILURE;
+      goto fallback;
     }
   }
   
@@ -968,7 +989,8 @@
       goto fallback;
     }
     
-    FD_SET(new_plugin->fd, &rfds_all);
+    FD_SET(new_plugin->fd, &rfds_all); /* Spurious warning from
+					  -Wconversion */
     
     if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
@@ -1028,7 +1050,8 @@
 	  }
 	  
 	  /* Remove the plugin */
-	  FD_CLR(proc->fd, &rfds_all);
+	  FD_CLR(proc->fd, &rfds_all); /* Spurious warning from
+					  -Wconversion */
 	  
 	  /* Block signal while modifying process_list */
 	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
@@ -1074,7 +1097,9 @@
       }
       
       /* This process has not completed.  Does it have any output? */
-      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
+      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){ /* Spurious
+							 warning from
+							 -Wconversion */
 	/* This process had nothing to say at this time */
 	proc = proc->next;
 	continue;

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2009-09-16 23:28:39 +0000
+++ plugins.d/askpass-fifo.c	2009-10-18 16:09:05 +0000
@@ -26,13 +26,19 @@
 #include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
-#include <errno.h>		/* errno, EEXIST */
+#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+				   ENAMETOOLONG, ENOSPC, EROFS,
+				   ENOENT, EEXIST, EFAULT, EMFILE,
+				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
+				   EISDIR, EFBIG */
 #include <stdio.h>		/* perror() */
 #include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
 #include <unistd.h>		/* read(), close(), write(),
 				   STDOUT_FILENO */
+#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
+				   EX_UNAVAILABLE, EX_IOERR */
 
 
 int main(__attribute__((unused))int argc,
@@ -43,16 +49,46 @@
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
-  if(ret == -1 and errno != EEXIST){
+  if(ret == -1){
+    int e = errno;
     perror("mkfifo");
-    return EXIT_FAILURE;
+    switch(e){
+    case EACCES:
+    case ENOTDIR:
+    case ELOOP:
+      return EX_OSFILE;
+    case ENAMETOOLONG:
+    case ENOSPC:
+    case EROFS:
+    default:
+      return EX_OSERR;
+    case ENOENT:
+      return EX_UNAVAILABLE;	/* no "/lib/cryptsetup"? */
+    case EEXIST:
+      break;			/* not an error */
+    }
   }
   
   /* Open FIFO */
   int fifo_fd = open(passfifo, O_RDONLY);
   if(fifo_fd == -1){
+    int e = errno;
     perror("open");
-    return EXIT_FAILURE;
+    switch(e){
+    case EACCES:
+    case ENOENT:
+    case EFAULT:
+      return EX_UNAVAILABLE;
+    case ENAMETOOLONG:
+    case EMFILE:
+    case ENFILE:
+    case ENOMEM:
+    default:
+      return EX_OSERR;
+    case ENOTDIR:
+    case ELOOP:
+      return EX_OSFILE;
+    }
   }
   
   /* Read from FIFO */
@@ -67,16 +103,28 @@
 	if(tmp == NULL){
 	  perror("realloc");
 	  free(buf);
-	  return EXIT_FAILURE;
+	  return EX_OSERR;
 	}
 	buf = tmp;
 	buf_allocated += blocksize;
       }
       sret = read(fifo_fd, buf + buf_len, buf_allocated - buf_len);
       if(sret == -1){
+	int e = errno;
+	free(buf);
+	errno = e;
 	perror("read");
-	free(buf);
-	return EXIT_FAILURE;
+	switch(e){
+	case EBADF:
+	case EFAULT:
+	case EINVAL:
+	default:
+	  return EX_OSERR;
+	case EIO:
+	  return EX_IOERR;
+	case EISDIR:
+	  return EX_UNAVAILABLE;
+	}
       }
       buf_len += (size_t)sret;
     } while(sret != 0);
@@ -90,13 +138,37 @@
   while(written < buf_len){
     sret = write(STDOUT_FILENO, buf + written, buf_len - written);
     if(sret == -1){
+      int e = errno;
+      free(buf);
+      errno = e;
       perror("write");
-      free(buf);
-      return EXIT_FAILURE;
+      switch(e){
+      case EBADF:
+      case EFAULT:
+      case EINVAL:
+	return EX_OSFILE;
+      case EFBIG:
+      case EIO:
+      case ENOSPC:
+      default:
+	return EX_IOERR;
+      }
     }
     written += (size_t)sret;
   }
   free(buf);
   
+  ret = close(STDOUT_FILENO);
+  if(ret == -1){
+    int e = errno;
+    perror("close");
+    switch(e){
+    case EBADF:
+      return EX_OSFILE;
+    case EIO:
+    default:
+      return EX_IOERR;
+    }
+  }
   return EXIT_SUCCESS;
 }

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-09-07 07:48:59 +0000
+++ plugins.d/password-prompt.c	2009-10-18 17:29:55 +0000
@@ -40,8 +40,10 @@
 				   getopt_long, getenv() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), perror(), fputc(),
-				   stdout, getopt_long */
-#include <errno.h>		/* errno, EINVAL */
+				   getopt_long */
+#include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
+				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
+				*/
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h> 		/* strlen, rindex, strncmp, strcmp */
@@ -50,6 +52,8 @@
 				   argp_parse(), error_t,
 				   ARGP_KEY_ARG, ARGP_KEY_END,
 				   ARGP_ERR_UNKNOWN */
+#include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
+				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -111,7 +115,7 @@
     ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
     if(ret == ARGP_ERR_UNKNOWN){
       fprintf(stderr, "Unknown error while parsing arguments\n");
-      return EXIT_FAILURE;
+      return EX_SOFTWARE;
     }
   }
   
@@ -123,25 +127,32 @@
   }
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
+    int e = errno;
     perror("tcgetattr");
-    return EXIT_FAILURE;
+    switch(e){
+    case EBADF:
+    case ENOTTY:
+      return EX_UNAVAILABLE;
+    default:
+      return EX_OSERR;
+    }
   }
   
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
      | [[info:libc:Initial Signal Actions]] |
@@ -150,37 +161,37 @@
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   
@@ -190,12 +201,20 @@
   }
   
   t_new = t_old;
-  t_new.c_lflag &= ~ECHO;
+  t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
+    int e = errno;
     perror("tcsetattr-echo");
-    return EXIT_FAILURE;
+    switch(e){
+    case EBADF:
+    case ENOTTY:
+      return EX_UNAVAILABLE;
+    case EINVAL:
+    default:
+      return EX_OSERR;
+    }
   }
-
+  
   if(debug){
     fprintf(stderr, "Waiting for input from stdin \n");
   }
@@ -237,7 +256,7 @@
       /* Make n = data size instead of allocated buffer size */
       n = (size_t)ret;
       /* Strip final newline */
-      if(n>0 and buffer[n-1] == '\n'){
+      if(n > 0 and buffer[n-1] == '\n'){
 	buffer[n-1] = '\0';	/* not strictly necessary */
 	n--;
       }
@@ -245,18 +264,55 @@
       while(written < n){
 	ret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(ret < 0){
+	  int e = errno;
 	  perror("write");
-	  status = EXIT_FAILURE;
+	  switch(e){
+	  case EBADF:
+	  case EFAULT:
+	  case EINVAL:
+	  case EFBIG:
+	  case EIO:
+	  case ENOSPC:
+	  default:
+	    status = EX_IOERR;
+	    break;
+	  case EINTR:
+	    status = EXIT_FAILURE;
+	    break;
+	  }
 	  break;
 	}
 	written += (size_t)ret;
       }
+      ret = close(STDOUT_FILENO);
+      if(ret == -1){
+	int e = errno;
+	perror("close");
+	switch(e){
+	case EBADF:
+	  status = EX_OSFILE;
+	  break;
+	case EIO:
+	default:
+	  status = EX_IOERR;
+	  break;
+	}
+      }
       break;
     }
     if(ret < 0){
+      int e = errno;
       if(errno != EINTR and not feof(stdin)){
 	perror("getline");
-	status = EXIT_FAILURE;
+	switch(e){
+	case EBADF:
+	  status = EX_UNAVAILABLE;
+	case EIO:
+	case EINVAL:
+	default:
+	  status = EX_IOERR;
+	  break;
+	}
 	break;
       }
     }
@@ -293,7 +349,7 @@
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);
   }
-  if(status == EXIT_SUCCESS){
+  if(status == EXIT_SUCCESS or status == EX_OK){
     fputc('\n', stderr);
   }
   

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2009-09-16 23:28:39 +0000
+++ plugins.d/splashy.c	2009-10-18 16:09:05 +0000
@@ -43,9 +43,16 @@
 				   STDOUT_FILENO, _exit(),
 				   pause() */
 #include <string.h>		/* memcmp() */
-#include <errno.h>		/* errno */
+#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+				   ENOENT, ENAMETOOLONG, EMFILE,
+				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
+				   E2BIG, EFAULT, EIO, ETXTBSY,
+				   EISDIR, ELIBBAD, EPERM, EINTR,
+				   ECHILD */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS() */
+#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
+				   EX_UNAVAILABLE */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
@@ -65,6 +72,7 @@
   DIR *proc_dir = NULL;
   pid_t splashy_pid = 0;
   pid_t splashy_command_pid = 0;
+  int exitstatus = EXIT_FAILURE;
   
   /* Create prompt string */
   {
@@ -90,6 +98,7 @@
     }
     if(ret == -1){
       prompt = NULL;
+      exitstatus = EX_OSERR;
       goto failure;
     }
   }
@@ -99,7 +108,23 @@
     const char splashy_name[] = "/sbin/splashy";
     proc_dir = opendir("/proc");
     if(proc_dir == NULL){
+      int e = errno;
       perror("opendir");
+      switch(e){
+      case EACCES:
+      case ENOTDIR:
+      case ELOOP:
+      case ENOENT:
+      default:
+	exitstatus = EX_OSFILE;
+	break;
+      case ENAMETOOLONG:
+      case EMFILE:
+      case ENFILE:
+      case ENOMEM:
+	exitstatus = EX_OSERR;
+	break;
+      }
       goto failure;
     }
     for(struct dirent *proc_ent = readdir(proc_dir);
@@ -127,6 +152,7 @@
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
 	  perror("asprintf");
+	  exitstatus = EX_OSERR;
 	  goto failure;
 	}
 	
@@ -138,8 +164,20 @@
 	    free(exe_link);
 	    continue;
 	  }
+	  int e = errno;
 	  perror("lstat");
 	  free(exe_link);
+	  switch(e){
+	  case EACCES:
+	  case ENOTDIR:
+	  case ELOOP:
+	  default:
+	    exitstatus = EX_OSFILE;
+	    break;
+	  case ENAMETOOLONG:
+	    exitstatus = EX_OSERR;
+	    break;
+	  }
 	  goto failure;
 	}
 	if(not S_ISLNK(exe_stat.st_mode)
@@ -163,6 +201,7 @@
     proc_dir = NULL;
   }
   if(splashy_pid == 0){
+    exitstatus = EX_UNAVAILABLE;
     goto failure;
   }
   
@@ -175,51 +214,60 @@
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
@@ -236,6 +284,7 @@
   }
   if(splashy_command_pid == -1){
     perror("fork");
+    exitstatus = EX_OSERR;
     goto failure;
   }
   /* Child */
@@ -243,7 +292,31 @@
     if(not interrupted_by_signal){
       const char splashy_command[] = "/sbin/splashy_update";
       execl(splashy_command, splashy_command, prompt, (char *)NULL);
+      int e = errno;
       perror("execl");
+      switch(e){
+      case EACCES:
+      case ENOENT:
+      case ENOEXEC:
+      case EINVAL:
+	_exit(EX_UNAVAILABLE);
+      case ENAMETOOLONG:
+      case E2BIG:
+      case ENOMEM:
+      case EFAULT:
+      case EIO:
+      case EMFILE:
+      case ENFILE:
+      case ETXTBSY:
+      default:
+	_exit(EX_OSERR);
+      case ENOTDIR:
+      case ELOOP:
+      case EISDIR:
+      case ELIBBAD:
+      case EPERM:
+	_exit(EX_OSFILE);
+      }
     }
     free(prompt);
     _exit(EXIT_FAILURE);
@@ -320,12 +393,28 @@
       ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
       if(ret == -1){
 	perror("dup2");
-	_exit(EXIT_FAILURE);
+	_exit(EX_OSERR);
       }
-    
+      
       execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
-      perror("execl");
-      _exit(EXIT_FAILURE);
+      {
+	int e = errno;
+	perror("execl");
+	switch(e){
+	case EACCES:
+	case ENOENT:
+	case ENOEXEC:
+	default:
+	  _exit(EX_UNAVAILABLE);
+	case ENAMETOOLONG:
+	case E2BIG:
+	case ENOMEM:
+	  _exit(EX_OSERR);
+	case ENOTDIR:
+	case ELOOP:
+	  _exit(EX_OSFILE);
+	}
+      }
     }
   }
   
@@ -348,5 +437,5 @@
     TEMP_FAILURE_RETRY(pause());
   }
   
-  return EXIT_FAILURE;
+  return exitstatus;
 }

